/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is CopySent2Current.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gBase=0x100;
var gSentAlso=0x10;
var gTrash=0x20;
var gDefSent=0x1;

var gHaveTrash=false;

function gg_setPickersState(event)
{
    document.getElementById('msgFccAccountPicker').setAttribute("disabled", "true");
    document.getElementById('msgFccFolderPicker').setAttribute("disabled", "true");
    gg_gui("false");

    var radioElemValue = event.target.value;
    gFccRadioElemChoice = radioElemValue;

    var checker=document.getElementById('gg_fcc2_toSend');
    if (checker.checked) gFccRadioElemChoice|=gSentAlso;
    if (gHaveTrash) {
      checker=document.getElementById('gg_fcc_noCopyIsTrash');
      if (checker.checked) gFccRadioElemChoice|=gTrash;
    }

    var radio = document.getElementById("gg_fcc_def");
    if (radio.selectedItem) {
      var defElemValue = radio.selectedItem.value;
      if (defElemValue!=0)
        gFccRadioElemChoice |= gDefSent;
      else
        gFccRadioElemChoice &= ~gDefSent;
    } else {
      radioElem = document.getElementById("gg_fcc_defiscur");
      radioElem.radioGroup.selectedItem = radioElem;
    }
}
function gg_setCheckersState(event)
{
  if (gFccRadioElemChoice>=gBase) { //test should not be necessary
    var checkElemValue = event.target.checked;
    var bit=event.target.id=='gg_fcc2_toSend'       ? gSentAlso :
            event.target.id=='gg_fcc_noCopyIsTrash'&&gHaveTrash ? gTrash    :
            0;
    if (checkElemValue)
      gFccRadioElemChoice |= bit;
    else
      gFccRadioElemChoice &= ~bit;
  }
}

function gg_setDefaultsState(event)
{
  if (gFccRadioElemChoice>=gBase) { //test should not be necessary
    var defElemValue = event.target.value;
    if (defElemValue!=0)
      gFccRadioElemChoice |= gDefSent;
    else
      gFccRadioElemChoice &= ~gDefSent;
  }
}

function gg_gui(disable) {
  document.getElementById('gg_fcc2_toSend').setAttribute("disabled", disable);
  document.getElementById('gg_fcc_noCopyIsTrash').setAttribute("disabled", gHaveTrash?disable:'true');

  var radio = document.getElementById("gg_fcc_def");
//  radio.setAttribute("disabled", disable);  //does not work :-(
  for (var i=0; i<radio.childNodes.length; i++)
    radio.childNodes[i].setAttribute("disabled", disable);
}


/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function onInitCopiesAndFolders()
{
  savedOnInitCopiesAndFolders();  // call original version, calls setupFccItems()

  var account = getAccountForFolderPickerState();
  if (!account || (
      account.incomingServer.type!='pop3' &&
      account.incomingServer.type!='imap' &&
      account.incomingServer.type!='movemail'
        )) {
    document.getElementById("gg_fcc_all").hidden=true;
  } else {
    /* convert old fccFolderPickerMode(2,3) to new */
//    var appInfo=
//      Components.classes["@mozilla.org/xre/app-info;1"].
//        getService(Components.interfaces.nsIXULAppInfo);
//    if (Number(appInfo.version.charAt(0))==1) {
      if      (gFccRadioElemChoice==2) { gFccRadioElemChoice=gBase; gg_gui("false"); }
      else if (gFccRadioElemChoice==3) { gFccRadioElemChoice=gBase|gSentAlso; gg_gui("false"); }
//    }


    /* check if trash folder available! */
    var trashFolderURI=document.getElementById("identity.fccFolder").value.replace(/[^\/]*$/,'Trash');
    var trashFolderResource=GetResourceFromUri(trashFolderURI);
    var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                     .QueryInterface(Components.interfaces.nsIWindowMediator)
                     .getEnumerator("mail:3pane");
    var w=windowsEnum.getNext();  // there must be one (the current)!
    var folderTree=w.GetFolderTree();
    gHaveTrash=w.GetFolderAttribute(folderTree, trashFolderResource, "SpecialFolder")=='Trash';
    if (!gHaveTrash)
      document.getElementById('gg_fcc_noCopyIsTrash').setAttribute("disabled", 'true');

    if (gFccRadioElemChoice>=gBase) {
      radioElem = document.getElementById("gg_fcc_selectOnSend");
      radioElem.radioGroup.selectedItem = radioElem;

      if (gFccRadioElemChoice&gSentAlso)
        document.getElementById("gg_fcc2_toSend").checked=true;
      if (gHaveTrash && gFccRadioElemChoice&gTrash)
        document.getElementById("gg_fcc_noCopyIsTrash").checked=true;

      if (gFccRadioElemChoice&gDefSent) {
        radioElem = document.getElementById("gg_fcc_defissent");
        radioElem.radioGroup.selectedItem = radioElem;
      } else {
        radioElem = document.getElementById("gg_fcc_defiscur");
        radioElem.radioGroup.selectedItem = radioElem;
      }
    }
  }
}

/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function onSaveCopiesAndFolders()
{
  if (gFccRadioElemChoice>=gBase) { //added!
    formElement = document.getElementById("identity.fccFolderPickerMode");
    formElement.setAttribute("value", gFccRadioElemChoice);
  } else  //do the default
    savedOnSaveCopiesAndFolders();  // call original version
}

/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function setupFccItems()
{
  savedSetupFccItems();   // call original version

  var checked = document.getElementById("identity.doFcc").checked;
  if (checked && gFccRadioElemChoice>=gBase) {
    var Picker = document.getElementById('msgFccAccountPicker');
    Picker.setAttribute("disabled", "true");
    Picker = document.getElementById('msgFccFolderPicker');
    Picker.setAttribute("disabled", "true");
  } else {
    gg_gui("true");
  }
}

/* Overloaded from chrome/messenger/content/messenger/am-copies.js */
function setPickersState() {
  // when this is called we must disable our elements
  gg_gui("true");
  return savedsetPickersState.apply(this, arguments);
}
